Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
题目就是说每一次变一个数,而且要求是素数,然后问最小变几次变成目标数,典型的BFS,先筛选出所有素数之后就直接爆搜就好。
代码如下:
#include<iostream> #include<cstring> #include<queue> using namespace std; bool rem[10005]; int rans[10005]; void getPrime() { for(int i=2;i<10000;++i) if(rem[i]==0) for(int j=i*2;j<10000;j+=i) rem[j]=1; } int bfs(int S,int E) { memset(rans,-1,sizeof(rans)); queue<int> que; int t; int temp; que.push(S); rans[S]=0; while(!que.empty()) { t=que.front(); que.pop(); if(t==E) return rans[E]; for(int i=1;i<=9;++i) { temp=t%1000+i*1000; if(rans[temp]==-1&&rem[temp]==0) { rans[temp]=rans[t]+1; que.push(temp); } } for(int i=0;i<=9;++i) { temp=t%100+100*i+(t/1000)*1000; if(rans[temp]==-1&&rem[temp]==0) { rans[temp]=rans[t]+1; que.push(temp); } } for(int i=0;i<=9;++i) { temp=t%10+10*i+(t/100)*100; if(rans[temp]==-1&&rem[temp]==0) { rans[temp]=rans[t]+1; que.push(temp); } } for(int i=0;i<=9;++i) { temp=(t/10)*10+i; if(rans[temp]==-1&&rem[temp]==0) { rans[temp]=rans[t]+1; que.push(temp); } } } return -1; } int main() { ios::sync_with_stdio(false); getPrime(); int T; int a,b; int ans; cin>>T; while(T--) { cin>>a>>b; ans=bfs(a,b); if(ans==-1) cout<<"Impossible "; else cout<<ans<<endl; } return 0; }